/* Copyright (C) 1996-2001 Ghostgum Software Pty Ltd.  All rights reserved.
  
  This file is part of AFPL Ghostscript.
  
  AFPL Ghostscript is distributed with NO WARRANTY OF ANY KIND.  No author or
  distributor accepts any responsibility for the consequences of using it, or
  for whether it serves any particular purpose or works at all, unless he or
  she says so in writing.  Refer to the Aladdin Free Public License (the
  "License") for full details.
  
  Every copy of AFPL Ghostscript must include a copy of the License, normally
  in a plain ASCII text file named PUBLIC.  The License grants you the right
  to copy, modify and redistribute AFPL Ghostscript, but only under certain
  conditions described in the License.  Among other things, the License
  requires that the copyright notice and this notice be preserved on all
  copies.
*/

/* $Id: gsplugin.c,v 1.0 2001/04/06 22:57:46 igorm Exp $ */

/* GS plugin handler */

#include "string_.h"
#include "ghost.h"
#include "gp.h"
#include "icontext.h"
#include "iapi.h"
#include "iref.h"
#include "iminst.h"
#include "ialloc.h"
#include "iplugins.h"

gs_plugin_retcode i_register_plugin(void *host, gs_plugin_interface *I)
{   i_ctx_t *i_ctx_p = ((gs_main_instance *)host)->i_ctx_p;
    if (i_ctx_p->interface_count >= count_of(i_ctx_p->I) - 1)
        return gs_plugin__rc_excess;
    i_ctx_p->I[i_ctx_p->interface_count] = I;
    i_ctx_p->interface_count ++;
    i_ctx_p->I[i_ctx_p->interface_count] = 0;
    return gs_plugin__rc_success;
}

gs_plugin_retcode i_unregister_plugin(void *host, gs_plugin_interface *I)
{   i_ctx_t *i_ctx_p = ((gs_main_instance *)host)->i_ctx_p;
    int k , j = 0;
    for (k = 0; k < i_ctx_p->interface_count; k++)
        if(i_ctx_p->I[k] != I)
           i_ctx_p->I[j++] = i_ctx_p->I[k];
    i_ctx_p->interface_count = j;
    return gs_plugin__rc_success;
}

gs_plugin_retcode i_unregister_plugin_client(gs_main_instance *minst)
{   return gs_unregister_plugin_client(0/* fixme */, minst);
}

gs_plugin_interface ** i_get_installed_plugins(i_ctx_t *i_ctx_p)
{   return i_ctx_p->I;
}
